# 从Internet Archive（archive.org)上获取指定collection中指定类型的item的identifier
# 获取的identifier每行一个，保存在items_output_warczone.txt，其中warczone为collection name
# 
# python 3.7.4，windows 11 x64测试通过
# pip3 install internetarchive
# archive.org上的搜索筛选语言，有两种模式，一种是在collection网页上直接选择语言（直接筛选），另一种是使用（高级搜索）。
# https://archive.org/details/warczone?and%5B%5D=language%3A%22English%22&and%5B%5D=language%3A%22Chinese%22
# https://archive.org/search?query=collection%3A%28warczone%29+AND+%28language%3A%28english%29+OR+language%3A%28chinese%29+OR+language%3A%28eng%29+OR+language%3A%28chi%29%29
# 直接筛选时只要选上English、Chinese即可，高级搜索时必须使用IA兼容的语言代码
# IA使用的语言代码列表：https://www.loc.gov/marc/languages/language_name.html
# 例如，英语需使用English 和 eng代码来搜索，中文对应Chinese 和 chi
# 参考资料：IA Metadata https://internetarchive.readthedocs.io/en/stable/metadata.html
# 已知问题：查询大量数据时，如有网络相关的报错，如ConnectionResetError等，原因是众所周知的网络状况不佳，需多次尝试。

import internetarchive
query = 'collection:(warczone) AND (language:(english) OR language:(chinese) OR language:(eng) OR language:(chi))'
items = internetarchive.search_items(query)
print(f"items found: {items.num_found}")
with open(r'E:\mnbvc\warc\items_output_warczone.txt', 'w') as outfile:
    for item in items:
        #获取identifier到文本
        outfile.write(item['identifier'] + '\n')